package org.mentawai.ajax.renders;

import java.lang.reflect.Method;
import java.util.Collection;
import java.util.Iterator;

import org.mentawai.ajax.AjaxRender;
import org.mentawai.core.Action;
import org.mentawai.core.Output;

public class BeanCollectionAjaxRender implements AjaxRender {
    public static final String DEFAULT_COLLECTION_ATTR = "beanCollection";
    public static final String DEFAULT_FATHER = "father";
    public static final String DEFAULT_CHILD = "child";
    
    
	
	private String collectionAttr = DEFAULT_COLLECTION_ATTR;
	private String father = DEFAULT_FATHER;
    private String child = DEFAULT_CHILD;
	private String[] subTagsAttrs;
    private String[] attrsAttrs; 
	
    public String renderize(Action action) throws Exception {
        Output output = action.getOutput();
        Collection collection = (Collection) output.getValue(collectionAttr);
        StringBuffer stringBuffer = new StringBuffer();
        stringBuffer.append('<').append(this.father).append('>');
        for (Iterator iterator = collection.iterator(); iterator.hasNext();) {
        	Object bean = iterator.next();
            Class<? extends Object> klass = bean.getClass();
        	stringBuffer.append('<').append(child);
            if (attrsAttrs != null) {
            	for (int i = 0; i < attrsAttrs.length; i++) {
            		String attrName = attrsAttrs[i];
                    Method method = klass.getMethod(arranjeToGetMethod(attrName), new Class[0]);
                    stringBuffer.append(' ').append(attrName).append("=\"").
                    append(method.invoke(bean, new Object[0])).append("\"");
            	}
            }
            else {
            	stringBuffer.append(' ');
            }
            stringBuffer.append('>');
            if (subTagsAttrs != null) {
            	for (int i = 0; i < subTagsAttrs.length; i++) {
            		String attrName = subTagsAttrs[i];
            		Method method = klass.getMethod(arranjeToGetMethod(attrName), new Class[0]);
            		stringBuffer.append('<').append(attrName).append('>').
            		append(method.invoke(bean, new Object[0])).append("</").append(attrName).
            		append('>');
            	}
            }
            stringBuffer.append("</").append(child).append('>');
        	iterator.remove();
        }
        stringBuffer.append("</").append(this.father).append('>');         
    	return stringBuffer.toString();
	}
    
    
    private static String arranjeToGetMethod(String name) {
		StringBuffer sb = new StringBuffer(30);
		sb.append("get");
		sb.append(name.substring(0,1).toUpperCase());
		if (name.length() > 1) { 
			sb.append(name.substring(1));
		}
		return sb.toString();
    	
    }


	public BeanCollectionAjaxRender(String collectionAttr ,String father, String child,  String[] subTagsAttrs, String[] attrsAttrs) {

		this.child = child;
		this.collectionAttr = collectionAttr;
		this.father = father;

		this.attrsAttrs = attrsAttrs;
		this.subTagsAttrs = subTagsAttrs;
	}


	public BeanCollectionAjaxRender(String[] subTagsAttrs, String[] attrsAttrs) {
		this.attrsAttrs = attrsAttrs;
		this.subTagsAttrs = subTagsAttrs;
	}


    public String getContentType() {
        return TEXT_XML;
    } 
}
