/*
 * Mentawai Web Framework http://mentawai.lohis.com.br/
 * Copyright (C) 2005  Sergio Oliveira Jr. (sergio.oliveira.jr@gmail.com)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package org.mentawai.tag;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Set;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.Tag;

import org.mentawai.tag.util.AbstractListContext;
import org.mentawai.tag.util.Context;

/**
 * @author Sergio Oliveira
 */
public class OutList extends AbstractListContext {
	
	private String value;
	
	public void setValue(String value) {
		this.value = value;
	}
    
    protected String getName() {
        return value;
    }
    
	public List<Object> getList() throws JspException {
        Tag parent = findAncestorWithClass(this, Context.class);
        if (parent != null) {
            Context ctx = (Context) parent;
            Object obj = ctx.getObject();
            if (obj != null) {
                Object object = Out.getValue(obj, value, false);
                if (object instanceof List) {
                    return (List<Object>) object;
                } else if (object instanceof Object[]) {
                    return Arrays.asList((Object[]) object);
                } else if (object instanceof Set) {
                    
                    // this is not good, but for now let's do it to support sets...
                    // A ListWrapper for a Set would be better to avoid copying...
                    
                    Set set = (Set) object;
                    
                    List<Object> list = new ArrayList<Object>(set);
                    
                    return list;
                    
                }
            }
        }   
        
        /*
		if (action != null) {
			Output output = action.getOutput();
			Object obj = output.getValue(value);
			if (obj instanceof List) {
				return (List) obj;
			} else if (obj instanceof Object[]) {
                return Arrays.asList((Object[]) obj);
            }
		}
        */
        
        Object obj = Out.getValue(value, pageContext, false);
        
        if (obj == null) return null;
        
        if (obj instanceof List) {
        	
        	return (List<Object>) obj;
        	
        } else if (obj instanceof Object[]) {
        	
        	return Arrays.asList((Object[]) obj);
        	
        } else if (obj instanceof Set) {
        	
        	// this is not good, but for now let's do it to support sets...
            // A ListWrapper for a Set would be better to avoid copying...
            
            Set set = (Set) obj;
            
            List<Object> list = new ArrayList<Object>(set);
            
            return list;
        	
        }
        
		throw new JspException("OutList: Value " + value +  " is not an instance of List or Object[]!");
	}
	
}

		
		
		
		