/*
 * Mentawai Web Framework http://mentawai.lohis.com.br/
 * Copyright (C) 2005  Sergio Oliveira Jr. (sergio.oliveira.jr@gmail.com)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package org.mentawai.tag.html.dyntag.inputDate;

import java.text.SimpleDateFormat;
import java.util.Date;

import javax.servlet.jsp.JspException;

import org.mentawai.formatter.Formatter;
import org.mentawai.formatter.FormatterManager;
import org.mentawai.tag.html.dyntag.inputDate.listener.InputDateListener;
import org.mentawai.tag.html.dyntag.inputText.InputText;

public class InputDate extends InputText {
	
	private static final long serialVersionUID = 1L;
	
	private String dateFormat   = "dd/mm/yyyy";
	private String titleButton  = null;
	/** Retorna o Formato da Data. */
	public String getDateFormat() {
		return dateFormat;
	}
	/** Seta o Formato da Data */
	public void setDateFormat(String dateFormat) {
		this.dateFormat = dateFormat;
	}
	
	public String getTitleButton() {
		return titleButton;
	}
	public void setTitleButton(String titleButton) {
		this.titleButton = titleButton;
	}
	
	
	/** Method to build tag */	
    public StringBuffer buildTag() {
    	StringBuffer results = new StringBuffer(super.buildTag().toString());
    	prepareAttribute(results,"maxlenght",getDateFormat().length()+"");
    	results.append(getTagClose());
    	results.append("&nbsp;");
	    results.append("<img");
	    prepareAttribute(results,"id",getName()+"-button");
	    prepareAttribute(results,"align","absmiddle");
	    prepareAttribute(results,"height","16");
	    prepareAttribute(results,"width","16");
	    prepareAttribute(results,"style","cursor:pointer");
	    prepareAttribute(results,"src",req.getContextPath()+InputDateListener.IMG_COMPONTENT);
        prepareAttribute(results,"onclick","return showCalendar('"+getId()+"','"+(getDateFormat().replaceFirst("yyyy","y"))+"')");
        prepareAttribute(results,"title",getTitleButton());
		prepareValue(results);
        results.append(getTagClose());
        results.append("\n");
        results.append("\t\t<script>");
	    //Changed document.forms[0] for document.getElementById()
        results.append("inputDateMask(document.getElementById(\""+getId()+"\"),\""+getDateFormat().replaceAll("[dmy]","9")+"\");");
	    results.append("</script>");
	    return results;
	}
	
	/** Method to prepare value component */
	protected void prepareValue(StringBuffer results){
		Object value = findObject(getName());		
		if (value != null) {
			if (value instanceof Date) {
				
				Formatter f = FormatterManager.getFixedDateFormatter();
				
				SimpleDateFormat formatter = new SimpleDateFormat(getDateFormat().replace('m','M'));
				
				Date date = (Date) value;
				
				if (f == null) {
				
					results.append(" value=\"").append(formatter.format(date)).append("\"");
					
				} else {
					
					results.append(" value=\"").append(f.format(date, loc)).append("\"");
				}
				
			} else {
				results.append(" value=\"").append(value).append("\"");
			}								
		} else if (getValue() != null) {
			results.append(" value=\"").append(getValue()).append("\"");
		}
	}
	
	public String getStringToPrint() throws JspException {
		StringBuffer results = new StringBuffer(200);
		results.append(buildTag().toString());		
		return results.toString();
	}
		
} 