/*
 * Mentawai Web Framework http://mentawai.lohis.com.br/
 * Copyright (C) 2005  Sergio Oliveira Jr. (sergio.oliveira.jr@gmail.com)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package org.mentawai.validation;

/**
 * An action should implement this interface if it wants to define its rules for validation.
 * 
 * This interface allows you to do dynamic validation, in other words, the method prepareValidator
 * will be called on every request.
 * 
 * If you don't need dynamic validation you should use the interface Validatable, so that the method
 * initValidator is called only once and cached.
 *
 * @author Sergio Oliveira
 */
public interface DynValidatable {
    
    public void prepareValidator(Validator validator, String innerAction);
    
}

